/* (c) Copyright 1985 Cary Buchman and Daniel M. Berry */
/* (c) Copyright 1987 Berry Computer Scientists, Ltd. */

/******************************************************* 
******************************************************** 
**                                                    **
** this file contains a number of supporting routines ** 
**                                                    **
******************************************************** 
*******************************************************/ 

#include <stdio.h>
#include "TOKEN.h"
#include "TABLE.h"
#include "macros.h"


/***********************************************************************/
/***********************************************************************/


/***************************************************
**************************************************** 
**                                                **
** this routine adds a new font to the font table **
**                                                **
**************************************************** 
***************************************************/

new_font(font_number,font_name,font_direction,font_table)

  int       font_number;
  char      *font_name;
  bool      font_direction;
  TABLENTRY font_table[];

{
  strcpy(font_table[font_number].name,font_name);
  font_table[font_number].direction = font_direction;

  return;
}


/***********************************************************
************************************************************ 
**                                                        **
** this routine determines the width of a character token **
**                                                        **
************************************************************ 
***********************************************************/

font_info(font_line,font_number,font_name)

  char  *font_line;                 /* LEX input token line */
  int   *font_number;               /* new font number      */
  char  *font_name[];               /* new font name        */

{

  int   i = 0;
  int   j = 0;
  char  f_num[4];
  
  while ((*(font_line+i) < '0') || (*(font_line+i) > '9'))
    i++;

  while ((*(font_line+i) >= '0') && (*(font_line+i) <= '9'))
  {
    f_num[j] = *(font_line+i);
    i++;
    j++;
  }
  f_num[j] = '\0';
  
  while (*(font_line+i) == ' ')
    i++;

  strcpy(font_name,font_line+i);
  *font_number = atoi(f_num);

  return;

}

/*************************************************
************************************************** 
**                                              **
** this routine prints an error message and     **
** halts execution upon OUT OF MEMORY condition **
**                                              **
************************************************** 
*************************************************/

out_of_memory()
{

  fprintf(stderr,"\nFATAL ERROR: out of memory\n");
  exit(1);

}


/*************************************************************************/
/*************************************************************************/


yywrap()
{
  return 1;
}

/*************************************************************************/
/*************************************************************************/


