/******************************************************************** 
********************************************************************* 
**                                                                 **
**   this file contains the type definition of the internal token  **
**   representation structure                                      **
**                                                                 **
********************************************************************* 
********************************************************************/ 

 typedef int bool;

 typedef struct tokn
 {
   int          token_type;                /* token type                 */
   int          point_size;                /* point size                 */
   int          font      ;                /* font number                */
   char         font_name[3];              /* font name                  */
   bool         lr        ;                /* font direction             */
   int          width     ;                /* character width            */
   int          vertical_pos;              /* vertical position          */
   int          horizontal_pos;            /* horizontal position        */
   bool         begining  ;                /* begining of word indicator */
   bool         ending    ;                /* end of word indicator      */
   int          fillers_num;               /* how many fillers to put    */
   int          filler_width;              /* the filler width           */
   int          manual_stretch_width;      /* manual amount to stretch */
                                           /* letter. Change #1 - harry */
   int          stretch_width;             /* automatic amount to */
			               	   /* stretch letter. Change */
               				   /* #1 - harry */
   int          stretch_filler_width;      /* automatic amount to */
			               	   /* stretch filler. Change */
               				   /* #2 - harry */
   int          manual_AC_width;           /* manual amount to stretch */
                                           /* AC of letter. Change #2 - harry */
   int          manual_BC_width;           /* manual amount to stretch */
                                           /* BC of letter. Change #2 - harry */
   int          AC_width;                  /* automatic amount to */
			               	   /* stretch AC of letter. Change */
               				   /* #2 - harry */
   int          BC_width;                  /* automatic amount to */
			               	   /* stretch BC of letter. Change */
               				   /* #2 - harry */
   char         char1     ;                /* 1st character of (abs)char token*/
   char         char2     ;                /* 2nd character of (abs)char token*/
   char         char3     ;                /* 3rd character of abs char token*/
   struct tokn  *next     ;                /* next token                 */
 } TOKENTYPE, *TOKENPTR;


/*************************************************************************/
/*************************************************************************/

